<?php
/*
+ ----------------------------------------------------------------------------------------------------+
|        e107 website system 
|        Email: office@clabteam.com
|        Organization: Corllete Lab Copyright 2007 Corllete ltd. - www.clabteam.com
|        $Id: user_style_theme.php 664 2007-11-08 14:37:18Z secretr $
|        License: GNU GENERAL PUBLIC LICENSE - http://www.gnu.org/licenses/gpl.txt
+----------------------------------------------------------------------------------------------------+
*/ 
if (!defined('e107_INIT')) { exit; }

function ustyle_theme_init(&$opt)
{
    global $pref, $USTYLE_OPT, $ustyle_theme_head;
    
    if(defined('USTYLE_THEME_INIT') && USTYLE_THEME_INIT)
        return;
        
	if(!check_class($pref['ustyle_permission']))
	   return;
    
    if(!$opt) $opt = &$USTYLE_OPT;
    
	$ustyle = ustyle_current_style();

	
	if($ustyle && !ustyle_inlist($ustyle)) {
	   $ustyle='';
	}
	
	$ustyle_theme_head = "";
	$current_style = $ustyle; 
	
	if(!USTYLE_DISABLE) {
        $opt['use_alternate'] = varsettrue($opt['use_alternate']);
        $alt = $opt['use_alternate'] ? 'alternate ' : '';
        
	   
        if($ustyle && file_exists(THEME.'user_style/'.ustyle_style2file($ustyle))) 
        {
            $ustyle = preg_replace('#[^a-zA-Z0-9_\-]#', '', $ustyle); 
            $current_style = $ustyle;
            $ustyle_theme_head .= "<link rel='{$alt}stylesheet' href='".(THEME_ABS.'user_style/'.ustyle_style2file($ustyle))."' type='text/css' title='{$ustyle}' />\n";
        }
        
        elseif($pref['ustyle_default_css'] && file_exists(THEME.'user_style/'.ustyle_style2file($pref['ustyle_default_css'])))
        {
            $current_style = $pref['ustyle_default_css'];
            $ustyle_theme_head .= "<link rel='{$alt}stylesheet' href='".(THEME_ABS.'user_style/'.ustyle_style2file($pref['ustyle_default_css']))."' type='text/css' title='{$current_style}' />\n";
            ustyle_set_style($current_style); 
        }
        
        elseif(varsettrue($opt['default_css']))
        {
            $current_style = ustyle_file2style($opt['default_css']);
            $ustyle_theme_head .= "<link rel='{$alt}stylesheet' href='".(THEME_ABS.'user_style/'.ustyle_style2file($opt['default_css']))."' type='text/css' title='{$current_style}' />\n";
            ustyle_set_style($current_style); 
        }
        
        elseif(file_exists(THEME.'user_style/style_default.css'))
        {
            $current_style = 'default';
            $ustyle_theme_head .= "<link rel='{$alt}stylesheet' href='".(THEME_ABS.'user_style/style_default.css')."' type='text/css' title='{$current_style}' />\n";
            ustyle_set_style('default');
        }

        if($opt['use_alternate']) {
            //load all styles (alternate & disabled)
            if($ustyles = ustyle_get_styles()) {
                foreach ($ustyles as $value) {
                    if($current_style == $value) continue;
                	$ustyle_theme_head .= "<link rel='alternate stylesheet' href='".(THEME_ABS.'user_style/'.ustyle_style2file($value))."' type='text/css' title='{$value}' />\n";
                } 
            }
            //include js switcher, disable not active stlyes            
            $ustyle_theme_head .= "<script type='text/javascript' src='".e_PLUGIN_ABS."user_style/ustyle_switch.js'></script>\n";
            
            $ustyle_theme_head .= "
            <script type='text/javascript'>
                //include e_ajax.js if required
                ustyleCheckeAjax('".e_FILE_ABS."e_ajax.js');
            </script>\n";
            
			$ustyle_theme_head .= "
            <script type='text/javascript'>
                ustyleSetActiveStyle('{$current_style}');
            </script>\n";
        }

    }
    
    //echo THEME.'user_style/style_'.$ustyle.'.css';
    $ustyle_theme_head .= varsettrue($opt['theme_header']) ? $opt['theme_header'] : '';
    
    if(!function_exists('theme_head') && $ustyle_theme_head) {
        function theme_head() {
            global $ustyle_theme_head, $pref;
            
            return "\n<!-- User Style v{$pref['ustyle_ver']} -->\n".$ustyle_theme_head;
        }
    }
    
    define('USTYLE_THEME_INIT', true);

}

function ustyle_get_styles($theme='', $all=false)
{
    global $fl, $pref;
    
    if(!$theme) $theme = defined('THEME') ? THEME : e_THEME.$pref['sitetheme'].'/';
    else $theme = e_THEME.$theme.'/';
    
    $pre = $all ? '1' : '0';
    
    if($ustyles = getcachedvars($pre.'_ustyle_styles_'.$theme))
        return $ustyles;
    
    $ustyles = array();
    
    if(!varset($fl)) {
        require_once(e_HANDLER.'file_class.php');
        $fl = new e_file;
    }
    
    $tmp = $fl -> get_files($theme.'user_style', '^style_.*(.css|.CSS)$');
    
    $ustyles = array();
    if($tmp) {
        //natsort($tmp);
        sort($tmp, "strnatcmp");
        
        foreach ($tmp as $value) {
            if($tmp = ustyle_file2style($value['fname'])) {
                if(!$all && !ustyle_inlist($tmp))
                    continue;
    
                $ustyles[] = $tmp;
            }
        }

    }

    cachevars($pre.'_ustyle_styles_'.$theme, $ustyles);
    
    return $ustyles;
}

function ustyle_inlist($style) 
{
    global $pref;
    
    $search = $pref['ustyle_csslist_allow'] ? explode(',', $pref['ustyle_csslist_allow']) : false;
    
    return !($search && $style != $pref['ustyle_default_css'] && !in_array($style, $search));
}

function ustyle_style2file($f) 
{
    $ret = 'style_'.$f.'.css';

    return $ret;
}

function ustyle_file2style($f) 
{
    $pattern = '/^style_([\w\-]+)\.css$/i';
    $ret = preg_replace($pattern, '\\1', $f);

    return $ret ? $ret : false;
}

function ustyle_style2name($style) 
{
    $pattern = '/^([0-9]+\_)/';
    $ret = preg_replace($pattern, '', $style);

    return $ret ? $ret : $style;
}

function ustyle_csslink($style, $index=false)
{
    //??? TO DO - Investigate: return e_SELF.'?'.urlencode('[ustyle|'.$style.']').e_QUERY;
    return ($index ? SITEURL.'index.php' : e_SELF).'?[ustyle|'.$style.']'.e_QUERY;
}

function ustyle_current_style()
{
	global $pref;
	if ($pref['user_tracking'] == "session") {
		$ustyle = $_SESSION['e107userstyle_'.$pref['cookie_name']];
	} else {
		$ustyle = $_COOKIE['e107userstyle_'.$pref['cookie_name']];
	}
    
	return $ustyle;
}

function ustyle_set_style($style='', $id=0)
{
	global $pref, $sql;
	
	if(!check_class($pref['ustyle_permission']) || !ustyle_inlist($style))
	   return;
	
	if ($pref['user_tracking'] == "session") {
		$_SESSION['e107userstyle_'.$pref['cookie_name']] = $style;
	} else {
        //if(!$_COOKIE['e107userstyle_'.$pref['cookie_name']])
        cookie('e107userstyle_'.$pref['cookie_name'], $style, time() + 86400, "/");
        $_COOKIE['e107userstyle_'.$pref['cookie_name']] = $style;
	} 
    
    if($id === FALSE || !USER) return;

    //update usersettings
    $id = $id ? intval($id) : USERID;
    $sql -> db_Update("user_extended", "user_ustyle_css='{$style}' WHERE  user_extended_id='".$id."'"); 
}

function ustyle_destroy_session()
{
	global $pref;
	
    if(!session_id())
    	@session_start(); //without errors
    $_SESSION['e107userstyle_'.$pref['cookie_name']] = '';
    
    cookie('e107userstyle_'.$pref['cookie_name'], "", (time() - 2592000));
	$_COOKIE['e107userstyle_'.$pref['cookie_name']] = '';
}

//INIT FUNCS
function user_style_catch()
{
    global $pref, $sql;
    
	if(!check_class($pref['ustyle_permission']))
        return;
        
    //$test = urldecode(e_QUERY);
    if(!USTYLE_DISABLE && e_MENU && strpos(e_MENU, 'ustyle|') !== FALSE) {
        $tmp = explode('|', e_MENU);
        $tmp[1] = preg_replace('#[^a-zA-Z0-9_\-]#', '',$tmp[1]); 
        
        //echo THEME.'user_style/style_'.$tmp[1].'.css'; exit;
        if(file_exists((defined('THEME') ? THEME : e_THEME.$pref['sitetheme'].'/').'user_style/style_'.$tmp[1].'.css')) {
        
            //do it
            ustyle_set_style($tmp[1]);
                
        }
        
        $url = e_SELF.(e_QUERY ? '?'.e_QUERY : '');

        if($pref['user_tracking'] == "session")
            session_write_close();
           
        header('Location: '.$url);
        exit;
    }
}

//TO DO - remove this to plugin administration!!!
function user_style_check($force=false)
{
    global $pref, $USER_STYLE_XFIELDS, $fl;
    
	if(!check_class($pref['ustyle_permission']))
	   return;
    
    if(e_PAGE == 'usersettings.php' || $force) {
    
        $ustyles = ustyle_get_styles();

        $upd = $ustyles ? "user_extended_struct_values='".implode(',', $ustyles)."'" : "user_extended_struct_values=''";
        
        require_once(e_PLUGIN.'user_style/includes/user_style_defaults.php');
        
        user_style_xfmodify($upd, 'ustyle_css');
        
    }
        
}
?>